moSellingStations = {};
source(MultiOverlayV3.modDir.."scripte/module/sellingStations/moSellingStationsConfig.lua");

function moSellingStations:update(dt)
	if moModule.active.sellingStationsSimple.isRunning then
		if moSellingStations.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateSellingStationsSimple"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moSellingStations.values.updateTimer, name="updateSellingStationsSimple", repeatable=1, ms=false, action=moSellingStations.loadStations} ); 
		else
			moSellingStations:loadStations();
		end;
	end;
end;

function moSellingStations:loadStations()
	moSellingStations:loadSellingStations();	
end;

function moSellingStations:loadSellingStations()
	local playerFarmId = g_currentMission.player.farmId;	
	moFillTypes.values.bestPrice = {}; --new
	if moModule.sellingStations ~= nil and #moModule.sellingStations > 0 then
		local deleteObject = {};
		for index=1, #moModule.sellingStations do			
			if moModule.sellingStations[index] ~= nil then
				local isObject = moModule:isObject(moModule.sellingStations[index].object);
				if isObject then
					local station = moModule.sellingStations[index].object;
					if station ~= nil and station.sellingStation ~= nil then
						local stationName = Utils.getNoNil(moModule.sellingStations[index].name, "Unknown");						
						for fillType,isAccepted in pairs(station.sellingStation.acceptedFillTypes) do
							if isAccepted then
								local difficultyMultiplier = 1000;
								local multiplier = getMultiplier();
								local pricePerLiter = (((station.sellingStation.fillTypePrices[fillType]+station.sellingStation.fillTypePriceRandomDelta[fillType])*station.sellingStation.priceMultipliers[fillType])*multiplier)*difficultyMultiplier;						
								if moFillTypes.values.bestPrice[fillType] == nil then
									moFillTypes.values.bestPrice[fillType] = {};									
								end;
								if station.sellingStation:getIsFillTypeAllowed(fillType) then
									pricePerLiter = station.sellingStation:getEffectiveFillTypePrice(fillType)*difficultyMultiplier;
								end;
								--price Dynamic InGameMenuPricesFrame
								--local priceTrend = station.sellingStation:getCurrentPricingTrend(fillType.index);
								--local cellProfile = InGameMenuPricesFrame.PROFILE.PRICE_CELL_NEUTRAL;
								--if priceTrend ~= nil then
								--	if Utils.isBitSet(priceTrend, SellingStation.PRICE_GREAT_DEMAND) then
								--		cellProfile = InGameMenuPricesFrame.PROFILE.PRICE_CELL_GREAT_DEMAND;
								--	elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_CLIMBING) then
								--		cellProfile = InGameMenuPricesFrame.PROFILE.PRICE_CELL_TREND_UP;
								--	elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_FALLING) then
								--		cellProfile = InGameMenuPricesFrame.PROFILE.PRICE_CELL_TREND_DOWN;
								--	end;
								--end;
								--price Dynamic
								--if moFillTypes.values.greatDemand[fillType] ~= nil and moFillTypes.values.greatDemand[fillType].isRunning and moFillTypes.values.greatDemand[fillType].isValid then								
								--	if moFillTypes.values.greatDemand[fillType].stationName == stationName and string.len(moFillTypes.values.greatDemand[fillType].stationName) == string.len(stationName) then
								--		pricePerLiter = pricePerLiter*moFillTypes.values.greatDemand[fillType].multiplier;
								--	end;
								--end;
								moFillTypes.values.bestPrice[fillType][#moFillTypes.values.bestPrice[fillType]+1] = {pricePerLiter, stationName};																	
							end;
						end;
					end;
				else
					table.insert(deleteObject, index);
				end;				
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.sellingStations, index);
			end;
			moModule:slotOutputCmd(true);
		end;		
		function comp(w1,w2)		
			if w1[1] > w2[1] then
				return true;
			end;				
		end;		
		for index, _ in pairs(moFillTypes.values.bestPrice) do
			table.sort(moFillTypes.values.bestPrice[index], comp);
		end;		
		
		--sort by pricePerLiter
		
		
		--sort by stationName Old
		--local keys = {};
		--local newSortTable = {};
		--function sortTable(myTable)			
		--	for key, _ in pairs(myTable) do
		--		table.insert(keys, key);
		--	end
		--	table.sort(keys, function(keyLhs, keyRhs) return myTable[keyLhs].stationName < myTable[keyRhs].stationName end);
		--	for _, key in ipairs(keys) do
		--		table.insert(newSortTable, myTable[key]);
		--	end;
		--end;
		--sortTable(moSellingStations.values.stations);		
		--moSellingStations.values.stations = newSortTable;
		--sort by stationName		
	end;
end;

function getMultiplier()
	if MultiOverlayV3.isMp and not MultiOverlayV3.loadHostServer then return 1 else return EconomyManager.getPriceMultiplier();end;
end;
